#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include "buffer.h"
#include "stralloc.h"
#include "dnsresolv.h"
#include "dns.h"
#include "ip.h"
#include "exit.h"
#include "logmsg.h"

#define WHO "dnsfq"
#define MAXCNAME 10

stralloc ca = {0};
stralloc sa = {0};
stralloc ia = {0};

int main(int argc,char **argv)
{
  int i, r;
  char ip4str[IP4_FMT];
  char ip6str[IP6_FMT];

  if (!argv[1]) 
    logmsg(WHO,100,USAGE,"dnsfq fqdn");

  if (!stralloc_copys(&sa,argv[1])) 
    logmsg(WHO,111,FATAL,"out of memory");

  DNS_INIT
  buffer_put(buffer_1,sa.s,sa.len);
  buffer_puts(buffer_1," ");
  for (i = 0; i <= MAXCNAME; i++) {
    if ((r = dns_cname(&ca,&sa)) < 0) _exit(1);
    if (r > 0) {
      if (!stralloc_copy(&sa,&ca)) _exit(111);
      buffer_puts(buffer_1,"-> ");
      buffer_put(buffer_1,sa.s,sa.len);
      buffer_puts(buffer_1," ");
    } 
    else break;
  }
  buffer_putsflush(buffer_1,"\n");

  if ((i = dns_ip6(&ia,&sa)) > 0) {
    for (i = 0; i + 16 <= ia.len; i += 16) {
      if (ip6_isv4mapped(ia.s + i)) continue;
      buffer_put(buffer_1,ip6str,ip6_fmt(ip6str,ia.s + i));
      buffer_puts(buffer_1,"\n");
    }
  }

  if ((i = dns_ip4(&ia,&sa)) > 0) {
    for (i = 0; i + 4 <= ia.len;i += 4) {
      buffer_put(buffer_1,ip4str,ip4_fmt(ip4str,ia.s + i));
      buffer_puts(buffer_1,"\n");
    }
  }
  buffer_flush(buffer_1);

  _exit(0);
}
